'use strict';

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _enzyme = require('enzyme');

var _ramda = require('ramda');

var _reactTestRenderer = require('react-test-renderer');

var _reactTestRenderer2 = _interopRequireDefault(_reactTestRenderer);

var _ = require('../');

var _2 = _interopRequireDefault(_);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

describe('Cell', function () {
  var wrapper = (0, _enzyme.shallow)(_react2.default.createElement(
    _2.default,
    {
      textAlign: 'center',
      alignSelf: 'center',
      spanOptions: { 0: 12, 768: { cols: 6, className: 'col6' } },
      columns: 12,
      breakPoint: 768 },
    _react2.default.createElement(
      'div',
      null,
      'One'
    )
  ));
  var style = wrapper.prop('style');

  test('it passes white listed flex props to style', function () {
    expect((0, _ramda.has)('alignSelf')(style)).toBe(true);
    expect((0, _ramda.has)('textAlign')(style)).toBe(false);
  });

  test('it computes the width based on colums and span', function () {
    expect(style.width).toBe('50%');
  });

  test('it adds col6 className', function () {
    expect(wrapper.hasClass('col6')).toBe(true);
  });

  test('cell renders correctly', function () {
    var tree = _reactTestRenderer2.default.create(_react2.default.createElement(
      _2.default,
      {
        textAlign: 'center',
        alignSelf: 'center',
        spanOptions: { 0: 12, 768: { cols: 6, className: 'col6' } },
        columns: 12,
        breakPoint: 768 },
      _react2.default.createElement(
        'div',
        null,
        'One'
      )
    )).toJSON();

    expect(tree).toMatchSnapshot();
  });
});