'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _templateObject = _taggedTemplateLiteral(['\n  box-sizing: border-box;\n  flex: 0 0 auto;\n'], ['\n  box-sizing: border-box;\n  flex: 0 0 auto;\n']);

exports.default = Cell;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _ramda = require('ramda');

var _classnames2 = require('classnames');

var _classnames3 = _interopRequireDefault(_classnames2);

var _styledComponents = require('styled-components');

var _styledComponents2 = _interopRequireDefault(_styledComponents);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _taggedTemplateLiteral(strings, raw) { return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }

var CellWrapper = _styledComponents2.default.div(_templateObject);
var flexProperties = ['alignSelf', 'flexBasis', 'flexGrow', 'flexShrink', 'flex', 'order'];

function Cell(props) {
  var breakPoint = props.breakPoint,
      children = props.children,
      columns = props.columns,
      rest = _objectWithoutProperties(props, ['breakPoint', 'children', 'columns']);

  var spanOptions = (0, _ramda.over)((0, _ramda.lensProp)('0'), (0, _ramda.defaultTo)(columns), props.spanOptions);
  var span = (0, _ramda.prop)(breakPoint, spanOptions);
  var cols = (0, _ramda.when)((0, _ramda.is)(Object), (0, _ramda.prop)('cols'))(span);
  var className = (0, _ramda.ifElse)((0, _ramda.is)(Object), (0, _ramda.prop)('className'), _ramda.F)(span);
  var flexStyles = (0, _ramda.pick)(flexProperties)(rest);
  var width = cols / columns * 100 + '%';

  var cellClassName = (0, _classnames3.default)(_defineProperty({}, className, className));

  return _react2.default.createElement(
    CellWrapper,
    { style: _extends({}, flexStyles, { width: width }), className: cellClassName },
    children
  );
}