'use strict';

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; /* eslint-disable max-nested-callbacks */


var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _enzyme = require('enzyme');

var _ramda = require('ramda');

var _ = require('../');

var _2 = _interopRequireDefault(_);

var _Cell = require('../../Cell');

var _Cell2 = _interopRequireDefault(_Cell);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

describe('Cellulose', function () {
  var breakPoints = {
    768: 'point768',
    1024: { className: 'point1024' }
  };

  var wrapper = (0, _enzyme.mount)(_react2.default.createElement(
    _2.default,
    { columns: 12, breakPoints: breakPoints },
    _react2.default.createElement(
      _Cell2.default,
      { spanOptions: { 768: { cols: 6, className: 'col4' }, 1024: 8 } },
      _react2.default.createElement(
        'div',
        null,
        'One'
      )
    ),
    _react2.default.createElement(
      _Cell2.default,
      { spanOptions: { 768: 6, 1024: 4 } },
      _react2.default.createElement(
        'div',
        null,
        'Two'
      )
    )
  ));
  var instance = wrapper.instance();

  test('it passes breakPoint and columns to Cell', function () {
    var gridItems = wrapper.find(_Cell2.default);

    expect((0, _ramda.has)('breakPoint')(gridItems.first().props())).toBe(true);
    expect((0, _ramda.has)('columns')(gridItems.first().props())).toBe(true);
  });

  describe('breakPoint', function () {
    test('it returns a breakPoint of 0', function () {
      expect(instance.breakPoint(350, _extends({ 0: null }, breakPoints))).toBe('0');
    });
  });

  describe('breakPointClass', function () {
    test('it returns className value', function () {
      expect(instance.breakPointClass(768, _extends({ 0: null }, breakPoints))).toBe('point768');
      expect(instance.breakPointClass(0, _extends({ 0: { className: 'point0' } }, breakPoints))).toBe('point0');
    });
  });
});