'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _templateObject = _taggedTemplateLiteral(['\n  display: flex;\n  flex-wrap: wrap;\n  justify-content: space-around;\n'], ['\n  display: flex;\n  flex-wrap: wrap;\n  justify-content: space-around;\n']);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactMeasure = require('react-measure');

var _reactMeasure2 = _interopRequireDefault(_reactMeasure);

var _ramda = require('ramda');

var _classnames2 = require('classnames');

var _classnames3 = _interopRequireDefault(_classnames2);

var _styledComponents = require('styled-components');

var _styledComponents2 = _interopRequireDefault(_styledComponents);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function _taggedTemplateLiteral(strings, raw) { return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }

var CelluloseWrapper = _styledComponents2.default.div(_templateObject);

var Cellulose = function (_PureComponent) {
  _inherits(Cellulose, _PureComponent);

  function Cellulose() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, Cellulose);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = Cellulose.__proto__ || Object.getPrototypeOf(Cellulose)).call.apply(_ref, [this].concat(args))), _this), _this.flexProperties = ['alignContent', 'alignItems', 'flexDirection', 'flexFlow', 'flexWrap', 'justifyContent'], _this.breakPoint = function (width, breakPoints) {
      return (0, _ramda.compose)((0, _ramda.find)((0, _ramda.gt)(width)), (0, _ramda.sort)(function (a, b) {
        return b - a;
      }), _ramda.keys)(breakPoints);
    }, _this.breakPointClass = function (key, breakPoints) {
      return (0, _ramda.compose)((0, _ramda.when)((0, _ramda.is)(Object), (0, _ramda.prop)('className')), (0, _ramda.prop)(key))(breakPoints);
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(Cellulose, [{
    key: 'render',
    value: function render() {
      var _this2 = this;

      var _props = this.props,
          children = _props.children,
          columns = _props.columns;

      var flexStyles = (0, _ramda.pick)(this.flexProperties)(this.props);
      var breakPoints = (0, _ramda.over)((0, _ramda.lensProp)('0'), (0, _ramda.defaultTo)(null), this.props.breakPoints);

      return _react2.default.createElement(
        _reactMeasure2.default,
        null,
        function (_ref2) {
          var width = _ref2.width;

          var breakPoint = _this2.breakPoint(width, breakPoints);
          var breakPointClass = _this2.breakPointClass(breakPoint, breakPoints);

          var className = (0, _classnames3.default)(_defineProperty({}, breakPointClass, breakPointClass));

          return _react2.default.createElement(
            CelluloseWrapper,
            { style: flexStyles, className: className },
            _react2.default.Children.map(children, function (child) {
              return _react2.default.cloneElement(child, _extends({}, child.props, { breakPoint: breakPoint, columns: columns }));
            })
          );
        }
      );
    }
  }]);

  return Cellulose;
}(_react.PureComponent);

exports.default = Cellulose;